
// by Dr. Claudio Soto, 2021/08/16

/************************************************************************
* If you have problems loading webview2 please update/installed  your
* runtime version of webview2 from the following Microsoft link:
*
* https://go.microsoft.com/fwlink/p/?LinkId=2124703
* or
* https://developer.microsoft.com/es-es/microsoft-edge/webview2/
*************************************************************************/

*
* modify with TEXTBOX, STATUSBAR and new RESIZE by Jimmy
*

#include "hmg.ch"

#define OriginalX    1280
#define OriginalY    1024

Function Main

LOCAL cCurDir := GETCURRENTFOLDER()
// msginfo(cCurDir)

#IFDEF DEBUG
   IF Empty( GETVERSION_WEBVIEW2() )
      MsgStop( "No installed runtime version of webview2 was detected", "HMG WebView2" )
   ELSE
      MsgInfo( "Your installed webview2 runtime version is: " + hb_osNewline() + GETVERSION_WEBVIEW2(), "HMG WebView2" )
   ENDIF
#ENDIF

   DEFINE WINDOW Win_1 ;
      ROW 0 ;
      COL 0 ;
      WIDTH OriginalX ;
      HEIGHT OriginalY ;
      TITLE "HMG WebView2";
      ON SIZE     MyResize() ; // RESIZE_WEBVIEW2();
      ON MAXIMIZE MyResize() ; // RESIZE_WEBVIEW2();
      MAIN

      DEFINE STATUSBAR PARENT Win_1
         STATUSITEM "Hello" WIDTH OriginalX - 300
         KEYBOARD WIDTH 100
         DATE WIDTH 100
         CLOCK WIDTH 100
      END STATUSBAR

      DEFINE MAIN MENU
         DEFINE POPUP "Navigate"
            MENUITEM "HMG Home"    ACTION   NAVIGATE_WEBVIEW2( "http://www.hmgforum.com" )
            MENUITEM "local file"   ACTION   NAVIGATE_WEBVIEW2( "file:///" + cCurDir + "/index.html" )
            SEPARATOR
            MENUITEM "Exec Script"   ACTION   EXECUTESCRIPT_WEBVIEW2( "alert('hello webview');" )
            SEPARATOR
            MENUITEM "webview2 runtime version"   ACTION   MsgInfo( "Your installed webview2 runtime version is: " + hb_osNewline() + GETVERSION_WEBVIEW2(), "HMG WebView2" )
         END POPUP
      END MENU

      DEFINE TEXTBOX Text_Navigate
         ROW 0
         COL 0
         WIDTH OriginalX-10
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 12
         TOOLTIP ""
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         RIGHTALIGN .F.
         BACKCOLOR NIL
         FONTCOLOR NIL
         VALUE ""
         ON ENTER DoNavigate()
      END TEXTBOX

      DEFINE WINDOW WinHttp ;
           PARENT Win_1 ;
           AT 30, 0 ;
           WIDTH OriginalX HEIGHT OriginalY-80 ;
           PANEL ;
           NOCAPTION ;
           BACKCOLOR nil ;
           /* ON MAXIMIZE LayoutAdjust( "WinHttp",630, 810) */ ;
           /* ON SIZE     LayoutAdjust( "WinHttp",630, 810) */ ;
           /* ON MOUSEMOVE IF( lActiveMain = .T., DragMove( ThisWindow.Name ), nil ) */ ;
           /* ON MOUSEDRAG IF( lActiveMain = .T., DragHere( ThisWindow.Name ), nil ) */ ;
           ON PAINT nil
      END WINDOW

   END WINDOW

*  INIT_WEBVIEW2( Win_1.Handle, "https://srvet.blogspot.com/" )
   INIT_WEBVIEW2( WinHttp.Handle, "https://srvet.blogspot.com/" )

   Win_1.Center
   Win_1.Activate

Return

PROCEDURE MyResize()
LOCAL mainRow    := GetProperty( "Win_1", "Row" )
LOCAL mainCol    := GetProperty( "Win_1", "Col" )
LOCAL mainWidth  := GetProperty( "Win_1", "Width" )
LOCAL mainHeight := GetProperty( "Win_1", "Height" )
LOCAL nBorder    := GETBORDERWIDTH()
LOCAL nDivh
LOCAL nDivw

   nDivw := mainWidth  / OriginalX
   nDivh := mainHeight / OriginalY

   SetProperty("Win_1","Text_Navigate","Width", (OriginalX-10) * nDivw )

   SetProperty("WinHttp","Width", OriginalX * nDivw )
   SetProperty("WinHttp","Height", (OriginalY-80) * nDivh )
   RESIZE_WEBVIEW2()

Return

PROCEDURE DoNavigate()
LOCAL cNewURL :=  GetProperty( "Win_1", "Text_Navigate","VALUE")

   IF .NOT. "http://" $ LOWER(cNewURL) .OR. .NOT. "https://" $ LOWER(cNewURL)
      cNewURL := "https://" + cNewURL
   ENDIF

   SbarText(cNewURL)
   NAVIGATE_WEBVIEW2( cNewURL )
Return

PROCEDURE SbarText( cText )
LOCAL hWnd := GetControlHandle( "StatusBar", "Win_1" )

   SetProperty("Win_1","StatusBar","Item", 1 , cText )

RETURN

*
*
*
